<?php
/*
Plugin name: SFCe Facebook Time Tools
Description: Transforms time/date values from Facebook to local time and vice-versa, including DST
Version: 1.0
Author: Roger Howorth
Author URI: http://www.thehypervisor.com
Plugin URI: http://www.thehypervisor.com/simple-facebook-connect-extensions

License: GPL2

    Copyright 2009-2010  Roger Howorth  (email : roger@rogerh.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2, 
    as published by the Free Software Foundation. 
    
    You may NOT assume that you can use any other version of the GPL.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    The license for this software can likely be found here: 
    http://www.gnu.org/licenses/gpl-2.0.html
*/

function FBTimeToLocal($time) {
    // Use this to transform a Unix timestamp sent by Facebook to local time
    // Create a date string from Unix timestamp
    $dateString = date("r",$time);
    // Create new date object from $dateString
    $datetime = new DateTime($dateString);
    // Create Los Angeles timezone
    $la_time = new DateTimeZone('America/Los_Angeles');
    // Set LA timezone to the date object
    $datetime->setTimezone($la_time);
    // Calculate the timezone offset (DST included during calculations)
    $offset = $datetime->getOffset();
    // Facebook adds its timezone offset to the received timestamp
    // Cheat facebook by adding the offset he is going to subtract
    $offset = $offset*(-1);
    $datetime->modify($offset." seconds");
    // Return Unix timestamp
    return $datetime->format("U");
}

function FBTime($time,$timezone,$correction) {
    // Use this to transform a local timezone Unix timestamp to account for possible DST
    // Create a date string from Unix timestamp
    // Convert correction (hours) to seconds
    $correction = $correction * 3600;
    // Update time with correction factor, needed because of facebook bug
    $time = $time + $correction;
    $dateString = date("r",$time);
    // Create new date object from $dateString
    $datetime = new DateTime($dateString);
    // Create local timezone - e.g. Europe/London
    $local_time = new DateTimeZone($timezone);
    // Set local timezone to the date object
    $datetime->setTimezone($local_time);
    // Calculate the timezone offset (DST included during calculations)
    $offset = $datetime->getOffset();
    $datetime->modify($offset." seconds");
    // Return Unix timestamp
    return $datetime->format("U");
}


?>
